import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.sql.*;

public class uudisedSetup extends HttpServlet{
   static final String HEADER="<html><head><title>Setup</title><body><h1>Uudised setup</h1>";
   static final String FOOTER="</body></html>";

   static final String TYPES_TABLE="create table types (typeid INT NOT NULL AUTO_INCREMENT, name VARCHAR(100) NOT NULL, PRIMARY KEY (typeid), UNIQUE (name))";
   static final String MESSAGES_TABLE="create table messages (id INT NOT NULL AUTO_INCREMENT, msgauthor VARCHAR(100) NOT NULL, type INT NOT NULL, header VARCHAR(250) NOT NULL, contents TEXT NOT NULL, time TIMESTAMP, PRIMARY KEY (id), FOREIGN KEY typekey(type) REFERENCES types(typeid))";
   static final String COMMENTS_TABLE="create table comments (comid INT NOT NULL AUTO_INCREMENT, comauthor VARCHAR(100) NOT NULL , msgid INT NOT NULL, comcontents TEXT NOT NULL, comtime TIMESTAMP, PRIMARY KEY (comid), FOREIGN KEY msgkey(msgid) REFERENCES messages(id))";
   static final String[] types_array={"kultuur", "kunst", "teater", "muusika", "haridus", "kirjandus", "poliitika", "tehnika", "veider", "varia"};

  static final String HTML_FORM="<form><br>"+
				"<input type=\"submit\" name=\"messages\" value=\"create messages table\"><br>"+
				"<input type=\"submit\" name=\"comments\" value=\"create comments table\"><br>"+
				"<input type=\"submit\" name=\"types\" value=\"create types table\"><br>"+
				"<input type=\"submit\" name=\"typeslist\" value=\"create typesList\"><br>"+
				"</form><form>"+
				"<input type=\"hidden\" name=\"messages\">"+
				"<input type=\"hidden\" name=\"comments\">"+
				"<input type=\"hidden\" name=\"types\">"+
				"<input type=\"hidden\" name=\"typeslist\">"+
				"<input type=\"submit\" name=\"all\" value=\"create all tables\">"+
				"</form>";

   Connection connection;
   Statement statement;
   int jobsDone=0;
   int jobsOrdered=0;

   void openDatabase() throws Exception{
  	  Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
      connection=DriverManager.getConnection("jdbc:odbc:uudised", "", "");
   	  statement=connection.createStatement();
   }

   void closeDatabase() throws Exception{
		 if(connection!=null){
			connection.close();
		 }
   }

   public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException{
		mainFunction(request, response);
   }

   public void doPost(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException{
		mainFunction(request, response);
   }

   private String executeQuery(String tableName, String query){
		jobsOrdered++;
		try{
   	  		 statement.executeUpdate(query);
			 jobsDone++;
		}catch(Exception e){
			return "<h2>Error! can't create \""+tableName+"\"!</h2>"+e.getMessage()+"<br>";
		}	
		return "<h2>Table \""+tableName+"\" created!</h2><br>";
   }

	private String createTypesList(){
		jobsOrdered++;
		try{
			PreparedStatement ps=connection.prepareStatement("insert into types (name) values (?)");
	 		for(int i=0; i<types_array.length;i++){
					ps.setString(1, types_array[i]);
	 				ps.executeUpdate();
			}
			jobsDone++;
			return "<h2>TypesList created</h2><br>";
		}catch(Exception e){
			return "<h2>Error @ TypesList</h2>"+e.getMessage()+"<br>";
		}
	}

   private String processRequest(HttpServletRequest request){
	StringBuffer result=new StringBuffer();
	jobsDone=jobsOrdered=0;

	if (request.getParameter("types")!=null){
		result.append(executeQuery("types", TYPES_TABLE));
	}
	if (request.getParameter("messages")!=null){
		result.append(executeQuery("messages", MESSAGES_TABLE));
	}
	if (request.getParameter("comments")!=null){
		result.append(executeQuery("comments", COMMENTS_TABLE));
	}

	if (request.getParameter("typeslist")!=null){
		result.append(createTypesList());
	 }	

	if (jobsOrdered>0){
		result.append("<a href=\"#\" onClick=\"history.back(); return false\">Back</a><br>");
		result.append("Jobs ordered: "+jobsOrdered+" and  jobs done: "+jobsDone+". "+((float)jobsDone/(float)jobsOrdered*100)+"% of success!<br>");
	}else{
		result.append(HTML_FORM);
	}	
	return result.toString();
  }

  public void mainFunction(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException{
       	response.setContentType("text/html");
 		PrintWriter output=response.getWriter();
		output.print(HEADER);
		try{
			openDatabase();
			output.print(processRequest(request));
			closeDatabase();
		}catch(Exception e){
			output.print("<h1>Viga</h1>"+e.getMessage());
		}
		output.print(FOOTER);
  }
}
