import javax.microedition.lcdui.*;
import java.util.*;

public class M2ng extends Canvas implements CommandListener{
	static final int RUUTE_REAS=8;

	int ruuduKylg;
	int pikkus;
	int laius;
	
	int dx;
	int dy;

	Timer t;
	Vector Nupud=new Vector();
	Ruut valikuRuut=new Ruut(0,1,false);
	Ruut valitudRuut=new Ruut(0,1, false);
	boolean valitud=false;
	Ruut must;
	boolean liiguVasakule=false;
	Command exit=new Command("Vlju", Command.EXIT,1);
	Command undo=new Command("Undo", Command.SCREEN, 2);

	public M2ng(){
		addCommand(exit);
		addCommand(undo);
		setCommandListener(this);
		pikkus=getHeight();
		laius=getWidth();

		int lyhemKylg=pikkus>laius?laius:pikkus;
		ruuduKylg=lyhemKylg/RUUTE_REAS;

		dx=(laius-lyhemKylg)/2;
		dy=(pikkus-lyhemKylg)/2;

		reset();
	}

	public void commandAction(Command command, Displayable displayable) {
		if (command==exit){
			JaneseMang.instance.notifyDestroyed();
		}
	
		if (command==undo){
			teeUndo(); // ARVUTI KIK!
			teeUndo(); // MINU KIK!
		}	
	}

	void teeUndo(){
		if (JaneseMang.ajalugu.empty()){
			return;
		}
		Liigutus tmp=(Liigutus)JaneseMang.ajalugu.pop();
		Ruut nupp=getNupp(tmp.kuhu.x, tmp.kuhu.y);
		nupp.liiguta(tmp.kust.x, tmp.kust.y);
	}

	void reset(){
		if (!Nupud.isEmpty()){
			Nupud.removeAllElements();
		}

		for(int x=1; x<RUUTE_REAS; x+=2){
			Nupud.addElement(new Ruut(x,0, false));
		}
	
		must=new Ruut(0,1,true);
		if (must.liiguta(RUUTE_REAS/2, RUUTE_REAS-1)){
			must.liiguta(RUUTE_REAS/2-1, RUUTE_REAS-1);	
		}
		Nupud.addElement(must);
		JaneseMang.ajalugu.removeAllElements();
	}

	protected void paint(Graphics g){
		joonistaRuudustik(g);
		joonistaNupud(g);
		joonistaValikuRuut(g);
	}

	void joonistaRuudustik(Graphics g){
		g.setColor(255,255,255);
    		g.fillRect(0, 0, getWidth(), getHeight());

		g.setColor(0,0,0);
		for(int x=0; x<RUUTE_REAS; ++x){
			for(int y=0; y<RUUTE_REAS; ++y){
				if ((x%2)!=(y%2)){	
					g.fillRect(x*ruuduKylg+dx, y*ruuduKylg+dy, ruuduKylg, ruuduKylg);
				}
			}
		}
			
		if (valitud){
			g.setColor(255,0,0);
			g.fillRect(valitudRuut.x*ruuduKylg+dx, valitudRuut.y*ruuduKylg+dy, ruuduKylg, ruuduKylg);
		}
	}	

	void joonistaValikuRuut(Graphics g){
		g.setColor(255,0,0);
		g.drawRect(valikuRuut.x*ruuduKylg, valikuRuut.y*ruuduKylg, ruuduKylg, ruuduKylg);
		g.drawRect(valikuRuut.x*ruuduKylg+1, valikuRuut.y*ruuduKylg+1, ruuduKylg-2, ruuduKylg-2);
		
	}
	
	void joonistaNupud(Graphics g){
		Ruut tmp;

		for(int i=0; i<Nupud.size(); i++){
		   tmp=(Ruut)Nupud.elementAt(i);
		   if (tmp.olenMust){
			g.setColor(255,0,0);
		   }else{
			g.setColor(220,220,220);
		   }
		   g.fillArc(tmp.x*ruuduKylg+ruuduKylg/4, tmp.y*ruuduKylg+ruuduKylg/4, ruuduKylg-ruuduKylg/2,ruuduKylg-ruuduKylg/2,0,360);
		}
	}
	
	void liiguta(){
		repaint();
	}

	Ruut getNupp(int x, int y){
		if (x>=RUUTE_REAS || y>=RUUTE_REAS || x<0 || y<0){
			return new Ruut(0,1,false);
		}

		Ruut tmp;
		for(int i=0; i<Nupud.size(); i++){
		   tmp=(Ruut)Nupud.elementAt(i);
		   if (tmp.x==x && tmp.y==y){
			return tmp;
		   }
		}	
		return null;
	}
	
	void liigutaNuppu(){
		if (getNupp(valikuRuut.x, valikuRuut.y)!=null){
			return;
		}

		int ex=valikuRuut.x-valitudRuut.x;
		int ey=valikuRuut.y-valitudRuut.y;

		Ruut nupp=getNupp(valitudRuut.x, valitudRuut.y);
		if (ey==1){
			if (ex==1 || ex==-1){
				JaneseMang.ajalugu.push(new Liigutus(nupp, valikuRuut));
				nupp.liiguta(valikuRuut);
				valitud=false;

				liigutaMusta();
			}
		}

	}

	void Voit(){
		JaneseMang.kuvaEkraan(new Lopp(true));
	}

	void Kaotus(){
		JaneseMang.kuvaEkraan(new Lopp(false));
	}	

	void liigutaMusta(){

		// et ei lheks liiga rde!
		if (getNupp(must.x-1, must.y-1)==null && getNupp(must.x+1, must.y-1)==null){
			liiguVasakule=liiguVasakule?false:true;
		}
		Ruut tmp=new Ruut(0,1,true);
		tmp.liiguta(must);


        	if (liiguVasakule){
			if (getNupp(must.x-1, must.y-1)==null){
				must.liiguta(must.x-1, must.y-1);
			}else if (getNupp(must.x-1, must.y+1)==null){
				must.liiguta(must.x-1, must.y+1);
			}else if(getNupp(must.x+1, must.y-1)==null){
				must.liiguta(must.x+1, must.y-1);
			}else if(getNupp(must.x+1, must.y+1)==null){
				must.liiguta(must.x+1, must.y+1);
				liiguVasakule=false;
			}else{
				Voit();
			}
		}else{
			if (getNupp(must.x+1, must.y-1)==null){
				must.liiguta(must.x+1, must.y-1);
			}else if (getNupp(must.x+1, must.y+1)==null){
				must.liiguta(must.x+1, must.y+1);
			}else if(getNupp(must.x-1, must.y-1)==null){
				must.liiguta(must.x-1, must.y-1);
			}else if(getNupp(must.x-1, must.y+1)==null){
				must.liiguta(must.x-1, must.y+1);
				liiguVasakule=true;
			}else{
				Voit();
			}
		}
	
		JaneseMang.ajalugu.push(new Liigutus(tmp, must));
		if (must.y==0){
			Kaotus();
		}	
	}

	protected void keyPressed(int kood){
		if (getGameAction(kood)==RIGHT){
			if (valikuRuut.x<(RUUTE_REAS-1)){
				valikuRuut.x++;
			}
		}
		if (getGameAction(kood)==LEFT){
			if (valikuRuut.x>0){
				valikuRuut.x--;
			}
		}
		if (getGameAction(kood)==UP){
			if (valikuRuut.y>0){
				valikuRuut.y--;
			}
		}
		if (getGameAction(kood)==DOWN){
			if (valikuRuut.y<(RUUTE_REAS-1)){
				valikuRuut.y++;
			}
		}

		if (getGameAction(kood)==FIRE){
			if (valikuRuut.liiguta(valikuRuut.x, valikuRuut.y) && !valitud){
				Ruut mis=getNupp(valikuRuut.x, valikuRuut.y);
				if (mis!=null && !mis.olenMust){
					valitudRuut.x=valikuRuut.x;
					valitudRuut.y=valikuRuut.y;
					valitud=true;			
				}	
			} else if (valitud && valikuRuut.x==valitudRuut.x && valikuRuut.y==valitudRuut.y){
				valitud=false;
			}else{
				liigutaNuppu();
			}
		}
	}

	public void showNotify(){
		t=new Timer();
		TimerTask tt=new TimerTask(){
			public void run(){
				liiguta();
			}
		};
		t.schedule(tt,50,50);
	}

	public void hideNotify(){
		t.cancel();
	}
}

